unit CompStrU;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnComponentToString: TButton;
    memGuineaPig: TMemo;
    memComponentString: TMemo;
    btnStringToComponent: TButton;
    procedure btnComponentToStringClick(Sender: TObject);
    procedure btnStringToComponentClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnComponentToStringClick(Sender: TObject);
var
  InputStream, OutputStream: TMemoryStream;
  CompAsString: PChar;
begin
  InputStream := TMemoryStream.Create;
  OutputStream := TMemoryStream.Create;
  try
    { Put component on stream }
    InputStream.WriteComponent(memGuineaPig);
    { Reset pointer to beginning of input stream }
    InputStream.Seek(0, soFromBeginning);
    { Turn component into string }
    ObjectBinaryToText(InputStream, OutputStream);
    { Allocate a buffer to store string characters along with a null terminator }
    GetMem(CompAsString, OutputStream.Size + 1);
    try
      { Deal with terminator }
      CompAsString[OutputStream.Size] := #0;
      { Copy string to PChar buffer }
      Move(OutputStream.Memory^, CompAsString^, OutputStream.Size);
      { Get string displayed in memo }
      memComponentString.SetTextBuf(CompAsString)
    finally
      FreeMem(CompAsString, OutputStream.Size + 1)
    end
  finally
    InputStream.Free;
    OutputStream.Free;
  end;
end;

procedure TForm1.btnStringToComponentClick(Sender: TObject);
var
  InputStream, OutputStream: TMemoryStream;
begin
  InputStream := TMemoryStream.Create;
  OutputStream := TMemoryStream.Create;
  try
    { Make room for memo text and null terminator}
    InputStream.SetSize(memComponentString.GetTextLen + 1);
    { Copy memo text into stream }
    memComponentString.GetTextBuf(InputStream.Memory, InputStream.Size);
    { Go back to start of input stream }
    InputStream.Seek(0, soFromBeginning);
    { Turn string into component }
    ObjectTextToBinary(InputStream, OutputStream);
    { Go back to start of output stream }
    OutputStream.Seek(0, soFromBeginning);
    { Overwrite the old component properties with the new ones }
    OutputStream.ReadComponent(memGuineaPig)
  finally
    InputStream.Free;
    OutputStream.Free
  end
end;

end.
